<?php
 /**
 * Html2Pdf Plugin: Conversion from html to pdf.
 *
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Daniel Stonier <d.stonier@gmail.com>
 */

// must be run within Dokuwiki
if (!defined('DOKU_INC')) die();
if (!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN', DOKU_INC . 'lib/plugins/');
 
require_once (DOKU_PLUGIN . 'action.php');
 
class action_plugin_html2pdf extends DokuWiki_Action_Plugin
{
    /**
     * Constructor.
     */
    function action_plugin_html2pdf(){
    }

    /**
     * return some info
     */
    function getInfo(){
        return confToHash(dirname(__FILE__).'/info.txt');
    }

    /**
     * Register the events
     */
    function register(&$controller)
    {
        $controller->register_hook('ACTION_ACT_PREPROCESS', 'BEFORE', $this, 'convert',array());
    }


    function convert(&$event, $param)
    {
        global $ACT;
	global $REV;
	global $ID;
	global $conf;

	//$ID = $param[0];
	if ( $ACT == 'export_pdf' ) {
	    $event->preventDefault();
	    $html = header('Content-Type: text/html; charset=utf-8');
	    $html .= '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"'.DOKU_LF;
	    $html .= ' "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'.DOKU_LF;
	    $html .= '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="'.$conf['lang'].'"'.DOKU_LF;
	    $html .= ' lang="'.$conf['lang'].'" dir="'.$lang['direction'].'">'.DOKU_LF;
	    $html .= '<head>'.DOKU_LF;
	    $html .= '  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />'.DOKU_LF;
	    $html .= '  <title>'.$ID.'</title>'.DOKU_LF;
	    // load stylesheets but skip the rest of the usual junk generated by tpl_metaheaders
	    $html .= '  <link rel="stylesheet" media="all" type="text/css" href="/doku/lib/exe/css.php?s=all"/>'.DOKU_LF;
	    $html .= '  <link rel="stylesheet" media="screen" type="text/css" href="/doku/lib/exe/css.php"/>'.DOKU_LF;
	    $html .= '</head>'.DOKU_LF;
	    $html .= '<body style="background:none;">'.DOKU_LF;
	    $html .= '<div class="dokuwiki">'.DOKU_LF;
	    $html .= p_wiki_xhtml($ID,$REV,false);
	    $html .= '</div>'.DOKU_LF;
	    $html .= '</body>'.DOKU_LF;
	    $html .= '</html>'.DOKU_LF;
	    // Replace images with dereferenced, gettable pictures
	    $pattern = '/<a.*?detail.php\/(.*?)\?.*?width="(.*?)" height="(.*?)".*?<\/a>/';
	    while ( preg_match($pattern,$html,$matches ) )
	    {
	        $link = preg_replace('/:/','/',$matches[1]);
	        // $matches[0] is the whole matching line
	        $width = $matches[2];
	        $height = $matches[3];
	        //$replace = '<img src="http://snorriheim.dnsdojo.com/doku/data/media/'.$link.'" class="media" alt="dokuwiki image" width="'.$width.'" height="'.$height.'" />';
	        $replace = '<img src="'.DOKU_URL.'data/media/'.$link.'" class="media" alt="dokuwiki image" width="'.$width.'" height="'.$height.'" />';
	        $html = preg_replace($pattern,$replace,$html);
	    }
	    // Dereference wiki links
	    $html = str_replace('href="/','href="http://'.$_SERVER['HTTP_HOST'].'/',$html);
	    $fout = fopen("lib/plugins/html2pdf/tmp/export_pdf.html",'w');
	    fwrite($fout,$html);
	    fclose($fout);
	    // Ghostscript method is method=fastps, FPDF method is method=fpdf
	    // pdflib method is method=pdflib
	    header("Location: " .DOKU_URL.'/lib/plugins/html2pdf/html2ps/demo/html2ps.php?URL=http://'.$_SERVER['HTTP_HOST'].getBaseURL().'lib/plugins/html2pdf/tmp/export_pdf.html&pixels=1024&media=A4&method=fpdf&output=0&pdfversion=1.3&cssmedia=screen&renderlinks=1&renderimages=1&scalepoints=1&leftmargin=10&rightmargin=10&topmargin=10&bottommargin=10');
	    //header("Location: " .'../../html2ps/demo/html2ps.php?URL=http://'.$_SERVER['HTTP_HOST'].getBaseURL().'lib/plugins/html2pdf/tmp/export_pdf.html&pixels=1024&media=A4&method=fpdf&output=0&pdfversion=1.3&cssmedia=screen&renderlinks=1&renderimages=1&scalepoints=1&leftmargin=10&rightmargin=10&topmargin=10&bottommargin=10');
	    die();
	}
    }
}
?>
